CoE Training Course - "Interactive HPC with JupyterLab"
===================================================

## General Information

Interactive exploration and analysis of large amounts of data from scientific simulations, in-situ visualization and application control are convincing scenarios for explorative sciences. Based on the open source software JupyterLab, a way has been available for some time now that combines interactive with reproducible computing while at the same time meeting the challenges of support for the wide range of different workflows. The approach enables the creation of documents that combine live code with narrative text, mathematical equations, visualizations, interactive controls, and other extensive output.

However, a number of challenges must be mastered in order to make existing workflows ready for interactive high-performance computing. With so many possibilities, it's easy to lose sight of the big picture. The course offers an introduction to the world of possibilities of JupyterLab.

The following topics are covered:
- Introduction to JupyterLab
- Customizing JupyterLab
- JupyterLab on HPC resources
- Jupyter-JSC under the hood 

### Main Data:
**date:**  
  26+27 Mai 2021
  09:00-13:00 (UTC+2)

**venue:**  
  Online, Zoom  
  Registration is closed - the course is fully booked.  
  Meeting-ID, Password:  
    - personal link was send to every approved participant via email  
      - subject: CoE Training Course - "Interactive HPC with JupyterLab" Confirmation  

**instructors:**  
  Jens Henrik Göbbert, j.goebbert@fz-juelich.de
  Christian Witzler, c.witzler@fz-juelich.de 

**contents level:**  
  Beginner's contents:    20 %  
  Intermediate contents:  80 %  

**prerequisites:**  
  Experience in Python  

**workshop materials:**  
  GitLab repository: https://gitlab.version.fz-juelich.de/jupyter4jsc/CoE-2021.05-jupyter4hpc  
  shared notes: https://gitlab.version.fz-juelich.de/hedgedoc/oo2I4aZHSKO5elJJOLPk3w?view  

### Agenda:
 - day 1: JupyterLab Introduction
     - 9:00 - 11:00
         - Welcome and Login
         - Introducing JupyterLab
     - 11:00 - 11:30
         - Break
     - 11:30 - 13:00
         - JupyterLab extensions tour
         - Customizing your environment
         
 - day 2: Jupyterlab for HPC
     - 9:00 - 11:00
         - Welcome and Login
         - Build your own kernels
         - Using JupyterLab as Proxy
     - 11:00 - 11:30
         - Break
     - 11:30 - 13:00
         - Utilizing supercomputers with JupyterLab
         - Jupyter-JSC under the hood

## Pre-Workshop Todos
 - **Register** at https://judoor.fz-juelich.de - [**Video-Howto (1:10)**](https://drive.google.com/file/d/1-DfiNBP4Gta0av4lQmubkXIXzr2FW4a-/view)
    - Click on "Register"
    - Enter the email address you used to register for this event
    - Click on "Send confirmation mail..."
    - Open the confirmation email in your email program
    - Click the confirmation link
 - **Join** the training project - [**Video-Howto (1:06)**](https://drive.google.com/file/d/1XdQSdML_jqGqvr_2WXqzlE-G6hiuYE2_/view)
     - Login to https://judoor.fz-juelich.de
     - Scroll to section "Projects"
     - Hit the link "Join a project"
     - Enter the Project id:
         - "**training2109**" for this training course
     - Click on "Join project"
 - **Please be patient**
     - **This takes as long as the PI needs to respond!** 
     - The PI has to accept your join-request first
     - After acceptance
         - project will be listed in section "Projects" 
         - systems will be listed in section "Systems"
 - **Sign usage agreement** - [**Video-Howto (1:13)**](https://drive.google.com/file/d/1mEN1GmWyGFp75uMIi4d6Tpek2NC_X8eY/view)
     - Login to https://judoor.fz-juelich.de
     - Scroll to section "Systems"
     - Click on "You need to _sign the usage agreement_ to access this system"
     - Sign the usage agreement
 - **Please be patient**
     - **This may take up to 10 minutes!**
     - Your HPC accounts will now be created on the desired systems.
     - Shortly after your HPC accounts are prepared you will see 
         - "jupyter-jsc" in the section "Connected Services"
 - **Login** at https://jupyter-jsc.fz-juelich.de - [**Video-Howto (1:34)**](https://drive.google.com/file/d/1S8_DaZRjBUOv7S3xT_KO8WFf44BqlR0O/view)
     - Click on "Login"
     - Login with your new **JSC account**
     - If this is your first login
         - click on "Register"
         - agree to the terms of service
         - click the link in the confirmation mail
 - **CONGRATULATIONS - YOU ARE READY FOR THE TRAINING COURSE**
